# python  C:\Users\rafae\Dropbox\clean_cache.py
# python  C:\Users\rafae\Dropbox\workspace\code\202109_stag_interp_v5\all_interp\code\scheduler.py
# python  C:\Users\rafae\Dropbox\clean_cache.py

# ------------------------------------------------------------------------
#                  Basic Library
# ------------------------------------------------------------------------

from  os       import  listdir  as  os_listdir
from  os       import  system   as  os_system
from  re       import  search   as  re_search
from  os.path  import  join     as  pjoin
from  os.path  import  isfile, isdir, abspath, dirname, basename
from  sys      import  argv
from  sys      import  platform as  sys_platform

# ------------------------------------------------------------------------
#                  Custom Library
# ------------------------------------------------------------------------

from core.utils     import lfilter  , lmap
from core.io_access import data_dirs, listdir_full

# ------------------------------------------------------------------------
#                  Basic Functions
# ------------------------------------------------------------------------

listdir_full_folders  =  lambda x   : lfilter(isdir , listdir_full(x))
listdir_full_files    =  lambda x   : lfilter(isfile, listdir_full(x))

def deepdirname(x, n, tag=None):
    for _ in range(n):
        x = dirname(x)
    if not (tag is None):
     assert tag in basename(x)
    return x

get_folder_user       =  lambda tag = 'rafae'   : deepdirname(abspath(__file__), 7, tag)
get_folder_cloud      =  lambda tag = 'Dropbox' : deepdirname(abspath(__file__), 6, tag)

# ------------------------------------------------------------------------
#                  Folder Paths
# ------------------------------------------------------------------------

unzipped_dns_dir  =  data_dirs.unzipped_dns_dir

# ------------------------------------------------------------------------
#                  Direct Runner
# ------------------------------------------------------------------------

if __name__ == "__main__":
    
    if 'linux' in sys_platform:
        python_path     =  'python'
    else:
        python_path     =  f'{pjoin(get_folder_user ()        , "anaconda3","Scripts","activate.bat")} && python'
    cache_abspath       =     pjoin(get_folder_cloud()        , "clean_cache.py"   )
    main_runner         =     pjoin(dirname(abspath(__file__)), "main.py"          )
    
    # all_chosen_folders  =  sorted(listdir_full_folders(unzipped_dns_dir))
    # all_chosen_folders = [pjoin(unzipped_dns_dir, 'refined_rand_r00'       ),
    #                       pjoin(unzipped_dns_dir, 'refined_abs_prod_rank01')]
    all_chosen_folders = [
                          
                          pjoin(unzipped_dns_dir, 'rand_r36' ),
                          pjoin(unzipped_dns_dir, 'rand_r37' ),
                          pjoin(unzipped_dns_dir, 'rand_r38' ),
                          pjoin(unzipped_dns_dir, 'rand_r39' ),
                          
                          pjoin(unzipped_dns_dir, 'abs_prod_rank37' ),
                          pjoin(unzipped_dns_dir, 'abs_prod_rank38' ),
                          pjoin(unzipped_dns_dir, 'abs_prod_rank39' ),
                          pjoin(unzipped_dns_dir, 'abs_prod_rank40' ),
                          
                          ]
    
    # this is important for the computer system to work
    assert len(all_chosen_folders) == len(set(map(basename,all_chosen_folders)))
    
    for folder in all_chosen_folders:
        os_system(f'{python_path} {cache_abspath}')
        os_system(f'{python_path} {main_runner} {folder}')