
# ------------------------------------------------------------------------
#                  Generic Libraries
# ------------------------------------------------------------------------

from   os.path  import  join                                       as  pjoin
from   os       import  listdir                                    as  os_listdir
from   sys      import  path                                       as  sys_path
from   os.path  import  isdir, basename, dirname, abspath, isfile
import numpy    as      np
from   sys      import  argv

# ------------------------------------------------------------------------
#                  Custom Libraries
# ------------------------------------------------------------------------

deepdirname           =  lambda x,n: x if n<1 else deepdirname(dirname(x),n-1)

sys_path.append(dirname(abspath(__file__)))
from  gather_data  import  Load_All_Tec
sys_path.pop()

# ------------------------------------------------------------------------
#                  Basic Functions
# ------------------------------------------------------------------------

lmap                  =  lambda f,x:  list   (map   (f,x))
lfilter               =  lambda f,x:  list   (filter(f,x))
listdir_full          =  lambda x  :  sorted (pjoin(x,y) for y in os_listdir(x))
listdir_full_files    =  lambda x  :  lfilter(isfile, listdir_full(x))
listdir_full_folders  =  lambda x  :  lfilter(isdir , listdir_full(x))

def reader(fname):
    with open(fname,'r') as f:
        return [x.rstrip('\n') for x in f]

def pop1(A):
    x, = A 
    return x

def import_pyjson(fname, comment = '#'):
    A = reader(fname)
    for i in range(len(A)):
        A[i] = A[i].split(comment)[0]
    result = eval(' '.join(A))
    assert not any((type(x)==str) for x in result.values())
    return result

# ------------------------------------------------------------------------
#                  Main Runner
# ------------------------------------------------------------------------

def Mk_summary_cf_nu(subfolder):
    fprint                       =   print
    side                         =  'bottom'
    qmode                        =  'Cf_classic'

    full_data, full_data_folder, props  =  Load_All_Tec(subfolder, side, qmode, fprint, apply_check=False)._get_full_export()

    fname_tec                    =  pjoin(full_data_folder, f'{subfolder}_summary_all_interp2center.tec')

    nx, nz                       =  np.array(full_data['X']).shape

    variables                    =  'VARIABLES ="' + ('", "'.join(full_data.keys())) + '" '
    zone                         =  f'ZONE I={nz} K={nx} F=POINT '

    with open(fname_tec, 'w') as f:
        write = lambda s: f.write(str(s).rstrip('\n') + '\n')
        write(variables)
        write(zone)
        write(f'# {props = }')
        for      i in  range(nx):
            for  j in  range(nz):
                write(' '.join(str(arr[i][j]) for arr in full_data.values()))

# ------------------------------------------------------------------------
#                  Direction Runner
# ------------------------------------------------------------------------

if __name__ == '__main__':
    
    _, subfolder            =  argv
    
    Mk_summary_cf_nu(subfolder)
